import type { DescExtension } from "@bufbuild/protobuf";
import { DescField, DescFile, LongType, ScalarType } from "@bufbuild/protobuf";
import type { GeneratedFile, Printable } from "./generated-file.js";
import type { ImportSymbol } from "./import-symbol.js";
export declare function makeFilePreamble(file: DescFile, pluginName: string, pluginVersion: string, parameter: string, tsNoCheck: boolean): string;
/**
 * Returns an expression for the TypeScript typing of a field,
 * and whether the property should be optional.
 */
export declare function getFieldTyping(field: DescField | DescExtension, file: GeneratedFile): {
    typing: Printable;
    optional: boolean;
};
export declare function scalarTypeScriptType(type: ScalarType, longType: LongType): Printable;
export declare function literalString(value: string): string;
export declare function getFieldExplicitDefaultValue(field: DescField | DescExtension, protoInt64Symbol: ImportSymbol): Printable | undefined;
export declare function getFieldIntrinsicDefaultValue(field: DescField): {
    defaultValue: Printable | undefined;
    typingInferrable: boolean;
};
